/** @file sdl_emu.cpp

	Skelton for retropc emulator
	SDL edition

	@author Sasaji
	@date   2012.02.21

	@brief [ sdl emulation i/f ]

	@note
	This code is based on the Common Source Code Project.
	Original Author : Takeda.Toshiya
*/

#include "sdl_emu.h"
#include "../../config.h"
#include "../../fileio.h"
#include "../../gui/gui.h"
//#include "ledbox.h"
#ifdef USE_MESSAGE_BOARD
#include "../../msgboard.h"
#endif
#include "sdl_csurface.h"

#ifdef USE_OPENGL
void EMU::change_screen_use_opengl(int num)
{
	_TCHAR msg[128];
	const _TCHAR *list[] = {
		_TX("OpenGL OFF"),
		_TX("OpenGL ON (Sync)"),
		_TX("OpenGL ON (Async)"),
		NULL
	};

	msg[0] = _T('\0');

#ifdef OPENGLONLY_ON_SDL2
	if (num >= 0) {
		config.use_opengl = num;
	} else {
		config.use_opengl = (config.use_opengl + 1) % 3;
		if (config.use_opengl == 0) config.use_opengl++;
	}
#else
	if (num >= 0) {
		config.use_opengl = (config.use_opengl == num) ? 0 : num;
	} else {
		config.use_opengl = (config.use_opengl + 1) % 3;
	}
#endif

	if (config.use_opengl != (uint8_t)get_parami(VM::ParamUseOpenGL)) {
		_tcscpy(msg, _TX(" (Need restart program)"));
	}
	out_infoc_x(list[config.use_opengl], msg, NULL);

#ifdef OPENGL_IMMCHANGE
// warning: cannot change immediate under agar gui
	use_opengl = config.use_opengl;
	if (!create_screen(config.screen_width, config.screen_height, screen_flags)) {
		exit(1);
	}
	lock_screen();
	update_config();
	unlock_screen();
#endif
}
#endif
